
; ******************************************************************************************************************
; **  PROGRAM MAKED BY FADISHOP  Card: FADIBUS	  http://www.fadishop.eu	FADITECO, S.L.U. 	Lleonard Garcia	**
; **  The SLAVE PCA9555N_A [$42] APPEAL BY INTO TO CPU. The SLAVE PCA9555N_B [$44] APPEAL BY INTO TO CPU.		**
; **  SLAVE [$42]_A: READ YOUR PORT 0, IMMEDIATELY IT TAKES FOR THE PORT_1. 							**
; **  SLAVE [$44]_B: READ YOUR PORT 0, IMMEDIATELY IT TAKES FOR THE PORT_1. 							**
; ** 	I2C SLAVE ADDRESS IS $ 42--> SW2[$42](A=0, B=0, C=1) SW1(I0=1, I1=0, I2=0, portC=0,  Rpullup=1)			**
; ** 	I2C SLAVE ADDRESS IS $ 44--> SW2[$42](A=0, B=1, C=0) SW1(I0=0, I1=1, I2=0, portC=0,  Rpullup=0)			**
; **											JP9 (does not affect JUMPER BLUE)			**
; **  CAUTION: WITH A ONE PULLUP RESISTOR FOR LINE INTERRUPT IS ENOUGH. (Rs or Rpullup)					**
; ******************************************************************************************************************
#picaxe 28x2
; SETTINGS
let dirsB=%00000000	; 1=output 0=input
let dirsC=%00000000	; 1=output 0=input
; C.3 I2C_SCL
; C.4 I2C_SDA
;adcsetup = %00000000 	; SETTING ANALOG
;setfreq em16		; Oscillator / external oscillator to 16Mhz.
; DEFINITIONS AND INITIALIZATIONS DEVICES.
device_PCA9555N:						;INTERNAL ADDRESS BUS EXPANDER PCA9555N
symbol inport_0 = 0					; Read register inputs port_0.
symbol inport_1 = 1					; Read register inputs port_1.
symbol outport_0 = 2					; Write register outputs port_0.
symbol outport_1 = 3					; Write register outputs port_0.
symbol polaritat_port_0 = 4				; Polarity register port_0 inputs -> 0 = no_inverted, 1 = inverted.
symbol polaritat_port_1 = 5				; Polarity register port_1 inputs -> 0 = no_inverted, 1 = inverted.
symbol config_port_0 = 6				; Configuration register port_0 as input or output. 1=input 0= utput.
symbol config_port_1 = 7				; Configuration register port_1 as input or output. 1=input 0= utput.	
; SETTINGS
config_PCA9555N_A:					;DEVICE_A SETUP (A, B, C, D, E, F, G, H. Maximum 8)
symbol adress_slave_A =$42				; I2C Address PCA9555N %0100ABC(rw). SLAVE PCA9555N (0X4E-0X4F).
symbol polport0_A = %00000000				; polarity port_0 inputs: 0-no inverted 1-logical inverted.
symbol polport1_A = %00000000				; polarity port_1 inputs: 0-no inverted 1-logical inverted.
symbol confport0_A = %11111111	; IN		; configuration port_0 1=input 0=output.
symbol confport1_A = %00000000	; OUT		; configuration port_0 1=input 0=output.
config_PCA9555N_B:					;DEVICE_B SETUP (A, B, C, D, E, F, G, H. Maximum 8)
symbol adress_slave_B =$44				; I2C Address PCA9555N %0100ABC(rw). SLAVE PCA9555N (0X4E-0X4F).
symbol polport0_B = %00000000				; polarity port_0 inputs: 0-no inverted 1-logical inverted.
symbol polport1_B = %00000000				; polarity port_1 inputs: 0-no inverted 1-logical inverted.
symbol confport0_B = %11111111	; IN		; configuration port_0 1=input 0=output.
symbol confport1_B = %00000000	; OUT		; configuration port_0 1=input 0=output.
transfer_config_PCA9555N_A:				;TRANSFER ALL SETTINGS TO DEVICE_A.
i2cslave adress_slave_A, i2cslow, i2cbyte		; send/call to address the peripheral/slave.
writei2c polaritat_port_0,(polport0_A,polport1_A); polarity send entries and port_1 port_0
writei2c config_port_0,(confport0_A,confport1_A); send configuration and port_1 port_0.
transfer_config_PCA9555N_B:				;TRANSFER ALL SETTINGS TO DEVICE_B.
i2cslave adress_slave_B, i2cslow, i2cbyte		; send/call to address the peripheral/slave.
writei2c polaritat_port_0,(polport0_B,polport1_B); polarity send entries and port_1 port_0
writei2c config_port_0,(confport0_B,confport1_B); send configuration and port_1 port_0.
configuracio_interrupcions:
symbol hint_setting = %00000011 			; Are triggered interrupts INT0 and INT1.
call restore_interrup					; CONTINUES. Shared common sequence located in interrupt.
;CYCLIC PROGRAM
main:								;CYCLIC PROGRAM
debug								; Take a pop all registros.Add delay.
goto main							; Start over.
;INTERRUPT SEQUENCE
interrupt:							; only serves the port of entry to be changed.
atenINT0:
if hint0flag=0 then atenINT1				; Interrupt INT0=1? (NO) JUMP
i2cslave adress_slave_B, i2cslow, i2cbyte		; (YES) send/call to address the peripheral/slave.
readi2c inport_0,(b0)					; reads the input port.				inport_0 --> b0
writei2c outport_1,(b0)					; read what is written in the port_1  	b0 --> outport_1
atenINT1:
if hint1flag=0 then  restore_interrup		; Interrupt INT1=1? (NO) JUMP
i2cslave adress_slave_B, i2cslow, i2cbyte		; (YES) send/call to address the peripheral/slave.
readi2c inport_0,(b0)					; reads the input port.				inport_0 --> b0
writei2c outport_1,(b0)					; read what is written in the port_1  	b0 --> outport_1
restore_interrup:
hint0flag = 0						; clear the INT0 flag.
hint1flag = 0						; clear the INT1 flag.
hintsetup hint_setting					; re-enable interrupts INT0 or INT1
setintflags or %00000011,%00000011 			; interrupts are enabled by INT0 or INT1 on falling edge.
return